<?php


namespace App\Export\WuxiLab;

use App\Export\BaseExport;
use App\Export\WuxiLab\Models\WuxiLabPackagesExportModel;
use App\Export\WuxiLab\Models\WuxiLabProductsExportModel;
use App\Export\WuxiLab\Models\WuxiLabStocksExportModel;

class WuxiLabExport extends BaseExport
{
    protected $defaultExportModel = ['product','package','stock'];
    protected $filePath = '';

    public function __construct()
    {
        parent::__construct();
    }

    public function getSavePath($fileName)
    {
        if($this->filePath == ''){
            $this->filePath = config('filesystem.default').'/public/Excel/';
        }
        return $this->filePath.date('Ymd',time()).'/'.$fileName;
    }

    public function getFileName($model)
    {
        return 'wuxiLab_'.$model.'_'.date('Y_m_d_His',time()).'.'.$this->expand;
    }

    /**
     * 存储到excel文件
     * @param $saveContent
     * @param null $model
     */
    public function saveExcel($saveContent,$model = null)
    {
        if($model == null){
            $model = $this->defaultExportModel;
        }

        if(!is_array($model) && $model != null){
            $model = explode(',',$model);
        }

        foreach($model as $m){
            switch($m){
                case 'product' :
                    $export = new WuxiLabProductsExportModel($saveContent['rawList']);
                    break;
                case 'package' :
                    $export = new WuxiLabPackagesExportModel($saveContent['packageList']);
                    break;
                case 'stock' :
                    $export = new WuxiLabStocksExportModel($saveContent['packageList']);
                    break;
            }
            $savePath = $this->getSavePath(
                $this->getFileName($m)
            );
            $this->storeExcel($export,$savePath);
        }
    }
}
